X-Git-Url: https://git.madduck.net/code/vcsh.git/blobdiff_plain/da296ac12ebac1ec10c3855fe62dac752cc5ff10..d15d05a5d3ea5c09c663cc8b61e2c69bf54bbc53:/vcsh

diff --git a/vcsh b/vcsh
index 38c1e0d..029c42c 100755
--- a/vcsh
+++ b/vcsh
@@ -1,178 +1,212 @@
 #!/bin/sh
 
-[ "$VCSH_DEBUG" = '1' ] && set -x
-
-SELF=$(basename $0)
-
+[ -n "$VCSH_DEBUG" ]      && set -x
 [ -z "$XDG_CONFIG_HOME" ] && XDG_CONFIG_HOME="$HOME/.config"
-for check_directory in $XDG_CONFIG_HOME $XDG_CONFIG_HOME/vcsh $XDG_CONFIG_HOME/vcsh/repo.d
-do
-	if [ ! -d "$check_directory" ]; then
-		if [ -e "$check_directory" ]; then
-			echo "$SELF: error: $check_directory exists but is not a directory" >&2
-			exit 2
-		else
-			mkdir $check_directory || (echo "$SELF: error: could not create $check_directory" >&2; exit 2)
-		fi
-	fi
-done
+[ -z "$VCSH_BASE" ]       && VCSH_BASE="$XDG_CONFIG_HOME/vcsh/repo.d"
 
-VCSH_BASE="$XDG_CONFIG_HOME/vcsh/repo.d"
-
-debug() {
-	[ "$VCSH_DEBUG" = '1' ] && echo "$SELF: debug: $1"
-}
-
-verbose() {
-	if [ "$VCSH_DEBUG" = '1' ] || [ "$VCSH_VERBOSE" = '1' ]; then echo "$SELF: verbose: $1"; fi
-}
+SELF=$(basename $0)
 
-#   use <repo>     Use this repository
 help() {
 	echo "usage: $SELF <args>
 
-   help              Display this help
-
-   list              List all repos
-
+   clone <remote> \\
+         [<repo>]       Clone from an existing repository
+   help                 Display this help text
+   delete               Delete an existing repository
+   enter                Enter repository; spawn new $SHELL
+   init <repo>          Initialize a new repository
+   list                 List all repositories
    run <repo> \\
-       <command>     Use this repository
+       <command>        Use this repository
 
-   init <repo>       Initialize a new repository
-   clone <remote> \\
-         [<repo>]    Clone from an existing repository
+   seed-gitignore \\
+   <repo>               Seed .gitignore.d/<repo> from git ls-files
+   setup                Set up repository with recommended settings
 
-   exit              Exit vcsh mode" >&2
+   <repo> <git command> Special command that allows you to run git commands
+                        directly without having to type so much ;)" >&2
 }
 
-use() {
-	verbose "use() begin"
-	REPO_NAME="$1"
-	GIT_DIR="$VCSH_BASE/$REPO_NAME.git"
-
-	if [ ! -d "$GIT_DIR" ]; then
-		echo E: no repository found for "$REPO_NAME" >&2
-		return 2
-	fi
+debug() {
+	[ -n "$VCSH_DEBUG" ] && echo "$SELF: debug: $@"
+}
 
-	export GIT_DIR
-	export GIT_WORK_TREE="$(git config --get core.worktree)"
-	export VCSH_DIRECTORY="$REPO_NAME"
-	verbose "use() end"
+verbose() {
+	if [ -n "$VCSH_DEBUG" ] || [ -n "$VCSH_VERBOSE" ]; then echo "$SELF: verbose: $@"; fi
 }
 
-init() {
-	verbose "init() begin"
-	[ -e "$GIT_DIR" ] &&
-		echo "$SELF: fatal: $GIT_DIR exists" &&
-		return 21
-	export GIT_WORK_TREE="$HOME"
-	mkdir -p $GIT_WORK_TREE
-	cd $GIT_WORK_TREE ||
-		(echo "$SELF: fatal: could not enter $GIT_WORK_TREE" &&
-		 exit 20) || exit 20
-	cd $GIT_WORK_TREE
-	git init
-	git config core.worktree $GIT_WORK_TREE
-	verbose "init() end"
+fatal() {
+	echo "$SELF: fatal: $1" >&2
+	exit $2
 }
 
-leave() {
-	unset GIT_DIR
-	unset GIT_WORK_TREE
-	unset VCSH_DIRECTORY
+error() {
+	echo "$SELF: error: $1" >&2
 }
 
-if [ "$1" = 'help' ] || [ "$#" -eq 0 ]; then
-	help
-	[ "$1" = 'help' ]
-	exit $?
+info() {
+	echo "$SELF: info: $1"
+}
 
-elif [ "$1" = 'list' ]; then
-	verbose "list begin"
-	for i in $VCSH_BASE/*.git; do
-		echo $(basename $i .git)
-	done
-	verbose "list end"
-	exit 0
-
-elif [ "$1" = 'run' ]; then
-	verbose "run begin"
-	use $2
-	shift 2
-	"$@"
-	leave
-	verbose "run end"
-	exit 0
-
-#elif [ "$1" = 'use' ]; then
-#	verbose "use begin"
-#	if [ -n "$ZSH_VERSION" ]; then
-#		if [ -o NO_IGNORE_EOF ]; then
-#			export VCSH_NO_IGNORE_EOF=1
-#			setopt IGNORE_EOF
-#		fi
-#		vcsh_exit() {
-#			vcsh exit;
-#			zle reset-prompt;
-#		}
-#		zle -N vcsh_exit
-#		bindkey '^d' 'vcsh_exit'
-#	fi
-#	use $2
-#	[ -n "$ZSH_VERSION" ] && [ "$USER" = richih ] && buildPS1
-#	verbose "use end"
-#	exit 0
-
-elif [ "$1" = 'clone' ]; then
-	verbose "clone begin"
-	GIT_REMOTE="$2"
-	REPO_NAME="$3"
-	[ -z "$REPO_NAME" ] && REPO_NAME=$(basename $GIT_REMOTE .git)
-	export REPO_NAME
-	export GIT_DIR="$VCSH_BASE/$REPO_NAME.git"
+clone() {
 	init
-
-	git remote add origin $GIT_REMOTE
+	git remote add origin "$GIT_REMOTE"
 	git config branch.master.remote origin
 	git config branch.master.merge  refs/heads/master
 	git fetch
 	for object in $(git ls-tree -r origin/master | awk '{print $4}'); do
 		[ -e "$object" ] &&
-			echo "$SELF: error: $object exists." &&
+			error "'$object' exists." &&
 			VCSH_CONFLICT=1;
 	done
 	[ "$VCSH_CONFLICT" = '1' ] &&
-		echo "$SELF: fatal: will stop after fetching and not try to merge!\n" &&
-		exit 3
+		fatal "will stop after fetching and not try to merge!
+  Once this situation has been resolved, run 'vcsh run $VCSH_REPO_NAME git pull' to finish cloning.\n" 17
 	git merge origin/master
-#	vcsh use $REPO_NAME
-	verbose "clone end"
-
-elif [ "$1" = 'init' ]; then
-	verbose "init begin"
-	[ -z $2 ] && help; return 0
-	export REPO_NAME="$2"
-	export GIT_DIR="$VCSH_BASE/$REPO_NAME.git"
-	init
-#	vcsh use $REPO_NAME
-	verbose "init end"
-
-elif [ "$1" = 'exit' ]; then
-	verbose "exit begin"
-	if [ -n "$ZSH_VERSION" ] && [ "$VCSH_NO_IGNORE_EOF" = '1' ]; then
-		unset VCSH_NO_IGNORE_EOF
-		setopt NO_IGNORE_EOF
+}
+
+delete() {
+	old_dir="$PWD"
+	cd "$HOME"
+	use
+	info "This operation WILL DETROY DATA!"
+	files=$(git ls-files)
+	echo "These files will be deleted:
+
+$files
+
+AGAIN, THIS WILL DELETE YOUR DATA!
+To continue, type \"Yes, do as I say\""
+	read answer
+	[ "x$answer" = "xYes, do as I say" ] || exit 16
+	for file in $files; do
+		rm -f $file || info "could not delete '$file', continuing with deletion"
+	done
+	rm -rf "$GIT_DIR" || info "could not delete '$GIT_DIR'"
+	cd "$old_dir"
+}
+
+enter() {
+	use
+	$SHELL
+}
+
+init() {
+	[ ! -e "$GIT_DIR" ] || fatal "'$GIT_DIR' exists" 10
+	export GIT_WORK_TREE="$HOME"
+	mkdir -p "$GIT_WORK_TREE"
+	cd "$GIT_WORK_TREE" || fatal "could not enter '$GIT_WORK_TREE'" 11
+	cd "$GIT_WORK_TREE"
+	git init
+	setup
+}
+
+list() {
+	for i in "$VCSH_BASE"/*.git; do
+		echo $(basename "$i" .git)
+	done
+}
+
+run() {
+	use
+	$VCSH_EXTERNAL_COMMAND
+}
+
+seed_gitignore() {
+	use
+	# Switching directory as this has to be executed from $HOME to be of any use.
+	# Going back into old directory at the end in case `vcsh use` is reactivated.
+	old_dir="$PWD"
+	cd "$HOME"
+	gitignores=$(for file in $(git ls-files); do
+		while true; do
+			echo $file; new="${file%/*}"
+			[ "$file" = "$new" ] && break
+			file="$new"
+		done;
+	done | sort -u)
+	tempfile=$(mktemp) || fatal "could not create tempfile" 51
+	echo '*' > "$tempfile"
+	for gitignore in $gitignores; do
+		echo "$gitignore" | sed 's/^/!/' >> "$tempfile"
+		[ -d "$gitignore" ] && echo "$gitignore/*" | sed 's/^/!/'>> "$tempfile"
+	done
+	diff -N "$tempfile" "$HOME/.gitignore.d/$VCSH_REPO_NAME" > /dev/null &&
+		rm -f "$tempfile" &&
+		exit
+	if [ -e "$HOME/.gitignore.d/$VCSH_REPO_NAME" ]; then
+		info "'$HOME/.gitignore.d/$VCSH_REPO_NAME' differs from new data, moving it to '$HOME/.gitignore.d/$VCSH_REPO_NAME.bak'"
+		mv -f "$HOME/.gitignore.d/$VCSH_REPO_NAME" "$HOME/.gitignore.d/$VCSH_REPO_NAME.bak" ||
+			fatal "could not move '$HOME/.gitignore.d/$VCSH_REPO_NAME' to '$HOME/.gitignore.d/$VCSH_REPO_NAME.bak'" 53
+	fi
+	mv -f "$tempfile" "$HOME/.gitignore.d/$VCSH_REPO_NAME" ||
+		fatal "could not move '$tempfile' to '$HOME/.gitignore.d/$VCSH_REPO_NAME'" 53
+	cd "$old_dir"
+}
+
+setup() {
+	use
+	git config core.worktree     "$GIT_WORK_TREE"
+	git config core.excludesfile ".gitignore.d/$VCSH_REPO_NAME"
+	git config vcsh.vcsh         'true'
+	touch   "$HOME/.gitignore.d/$VCSH_REPO_NAME"
+	git add "$HOME/.gitignore.d/$VCSH_REPO_NAME"
+}
+
+use() {
+	if [ ! -d "$GIT_DIR" ]; then
+		fatal "no repository found for '$VCSH_REPO_NAME'" 12
 	fi
-	leave
-	[ -n "$ZSH_VERSION" ] && [ "$USER" = richih ] && buildPS1
-	verbose "exit end"
-	exit 0
+	export GIT_WORK_TREE="$(git config --get core.worktree)"
+	export VCSH_DIRECTORY="$VCSH_REPO_NAME"
+}
 
+if [ "$1" = 'clone' ]; then
+	[ -z $2 ] && fatal "$1: please specify a remote" 1
+	export VCSH_COMMAND="$1"
+	GIT_REMOTE="$2"
+	[ -n "$3" ] && VCSH_REPO_NAME="$3" || VCSH_REPO_NAME=$(basename "$GIT_REMOTE" .git)
+	export VCSH_REPO_NAME
+	export GIT_DIR="$VCSH_BASE/$VCSH_REPO_NAME.git"
+elif [ "$1" = 'delete' ] ||
+     [ "$1" = 'enter' ] ||
+     [ "$1" = 'init' ] ||
+     [ "$1" = 'run' ] ||
+     [ "$1" = 'seed-gitignore' ] ||
+     [ "$1" = 'setup' ]; then
+	[ -z $2 ] && fatal "$1: please specify repository to work on" 1
+	[ "$1" = 'run' -a -z "$3" ] && fatal "$1: please specify a command" 1
+	export VCSH_COMMAND="$1"
+	export VCSH_REPO_NAME="$2"
+	export GIT_DIR="$VCSH_BASE/$VCSH_REPO_NAME.git"
+	[ "$VCSH_COMMAND" = 'run' ] && shift 2 && export VCSH_EXTERNAL_COMMAND="$@"
+	[ "$VCSH_COMMAND" = 'seed-gitignore' ] && export VCSH_COMMAND='seed_gitignore'
+elif [ "$1" = 'list' ]; then
+	export VCSH_COMMAND="$1"
+elif [ -n "$1" ]; then
+	export VCSH_COMMAND=run
+	export VCSH_REPO_NAME="$1"
+	export GIT_DIR="$VCSH_BASE/$VCSH_REPO_NAME.git"
+	[ -d $GIT_DIR ] || { help; exit 1; }
+	shift 1
+	export VCSH_EXTERNAL_COMMAND="git $*"
 else
-	verbose "defaulting to calling help()"
-	help
-	exit 3
-
+	# $1 is empty, or 'help'
+	help && exit
 fi
 
+for check_directory in "$VCSH_BASE" "$HOME/.gitignore.d"
+do
+	if [ ! -d "$check_directory" ]; then
+		if [ -e "$check_directory" ]; then
+			fatal "'$check_directory' exists but is not a directory" 13
+		else
+			info "attempting to create '$check_directory'"
+			mkdir -p "$check_directory" || fatal "could not create '$check_directory'" 50
+		fi
+	fi
+done
+
+verbose "$VCSH_COMMAND begin"
+$VCSH_COMMAND
+verbose "$VCSH_COMMAND end, exiting"